<!-- author: KAWSAR AHMED - kawsar.ahmed.cse@gmail.com  --> 
<html>
<head>
	<meta charset=utf-8 />
	<title>Ramadan Calender, 2019</title>
	<link rel="stylesheet" href="plugins/flipclock/flipclock.css">
	<link rel="stylesheet" href="css/style.css">
	<style type="text/css">
	</style>
</head>
<body class="theme-1">
	<script type="text/javascript"> if (!window.console) console = {log: function() {}}; </script>
	<script src="js/jquery/jquery-1.10.2.min.js"></script>
	<script src="js/moment.js"></script>
	<script src="plugins/flipclock/flipclock.min.js"></script>

	<table id="info-table" class="left-top smaller">
		<tr>
			<td colspan="2"><h1 class="highlight-1" style="font-size: 50px;" id="day"></h1></td>
		</tr>
		<tr>
			<td colspan="2" class="highlight-1 dark-back"><div class="clock" id="sehri-remaining"></div></td>
		</tr>
		<tr>
			<td><h1 class="highlight-1">Sehri:</h1></td>
			<td><h1 class="highlight-2" id="sehri"></h1></td>
		</tr>
		<tr>
			<td colspan="2" class="highlight-1 dark-back"><div class="clock" id="iftar-remaining"></div></td>
		</tr>
		<tr>
			<td><h1 class="highlight-1">Iftar:</h1></td>
			<td><h1 class="highlight-2" id="iftar"></h1></td>
		</tr>
	</table>

	<table id="main-counter-table" class="right-top highlight-1 dark-back">
		<tr>
			<td><div id="wakt-txt"></div></td>
		</tr>
		<tr>
			<td><div id="main-clock" class="clock"></div></td>
		</tr>
	</table>

	<table id="theme-table" class="left-bottom dark-back" title="click to select the theme">
		<tr>
			<td>
				<div class="theme-select" themeClass="theme-1">
					<img src="images/theme-1.jpg" height="20px">
				</div>
			</td>
			<td>
				<div class="theme-select" themeClass="theme-2">
					<img src="images/theme-2.jpg" height="20px">
				</div>
			</td>
			<td>
				<div class="theme-select" themeClass="theme-3">
					<img src="images/theme-3.jpg" height="20px">
				</div>
			</td>
			<td>
				<div class="theme-select" themeClass="theme-4">
					<img src="images/theme-4.jpg" height="20px">
				</div>
			</td>
			<td>
				<div class="theme-select" themeClass="theme-5">
					<img src="images/theme-5.jpg" height="20px">
				</div>
			</td>
		</tr>
	</table>
	<table id="date-time" class="right-bottom highlight-1 dark-back smaller">
		<tr>
			<td><div id="date"></div></td>
		</tr>
		<tr>
			<td><div id="time" class="clock"></div></td>
		</tr>
	</table>

	
<script type="text/javascript">

	var Schedules = {
		"07-05-19": { day:  1, sehri: "03:52 AM", iftar: "06:34 PM" },
		"08-05-19": { day:  2, sehri: "03:51 AM", iftar: "06:34 PM" },
		"09-05-19": { day:  3, sehri: "03:50 AM", iftar: "06:35 PM" },
		"10-05-19": { day:  4, sehri: "03:50 AM", iftar: "06:35 PM" },
		"11-05-19": { day:  5, sehri: "03:49 AM", iftar: "06:36 PM" },
		"12-05-19": { day:  6, sehri: "03:49 AM", iftar: "06:36 PM" },
		"13-05-19": { day:  7, sehri: "03:47 AM", iftar: "06:36 PM" },
		"14-05-19": { day:  8, sehri: "03:48 AM", iftar: "06:37 PM" },
		"15-05-19": { day:  9, sehri: "03:48 AM", iftar: "06:37 PM" },
		"16-05-19": { day: 10, sehri: "03:47 AM", iftar: "06:38 PM" },
		"17-05-19": { day: 11, sehri: "03:46 AM", iftar: "06:38 PM" },
		"18-05-19": { day: 12, sehri: "03:46 AM", iftar: "06:39 PM" },
		"19-05-19": { day: 13, sehri: "03:45 AM", iftar: "06:39 PM" },
		"20-05-19": { day: 14, sehri: "03:44 AM", iftar: "06:40 PM" },
		"21-05-19": { day: 15, sehri: "03:44 AM", iftar: "06:40 PM" },
		"22-05-19": { day: 16, sehri: "03:43 AM", iftar: "06:41 PM" },
		"23-05-19": { day: 17, sehri: "03:43 AM", iftar: "06:42 PM" },
		"24-05-19": { day: 18, sehri: "03:42 AM", iftar: "06:42 PM" },
		"25-05-19": { day: 19, sehri: "03:42 AM", iftar: "06:42 PM" },
		"26-05-19": { day: 20, sehri: "03:41 AM", iftar: "06:43 PM" },
		"27-05-19": { day: 21, sehri: "03:41 AM", iftar: "06:43 PM" },
		"28-05-19": { day: 22, sehri: "03:40 AM", iftar: "06:44 PM" },
		"29-05-19": { day: 23, sehri: "03:40 AM", iftar: "06:44 PM" },
		"30-05-19": { day: 24, sehri: "03:40 AM", iftar: "06:45 PM" },
		"31-05-19": { day: 25, sehri: "03:39 AM", iftar: "06:45 PM" },
		"01-06-19": { day: 26, sehri: "03:39 AM", iftar: "06:46 PM" },
		"02-06-19": { day: 27, sehri: "03:39 AM", iftar: "06:46 PM" },
		"03-06-19": { day: 28, sehri: "03:39 AM", iftar: "06:46 PM" },
		"04-06-19": { day: 29, sehri: "03:39 AM", iftar: "06:47 PM" },
		"05-06-19": { day: 30, sehri: "03:39 AM", iftar: "06:47 PM" },
		"06-06-19": { day: 31, sehri: "03:38 AM", iftar: "06:48 PM" }
	};

	$(document).ready(function() {
		var mainClockElm = $('#main-clock');
		var dateElm = $("#date");
		var timeElm = $("#time");
		var dayElm = $("#day");
		var sehriElm = $("#sehri");
		var iftarElm = $("#iftar");
		var sehriRemElm = $("#sehri-remaining");
		var iftarRemElm = $("#iftar-remaining");
		var waktTxtElm = $("#wakt-txt");
		var dateFormat = "DD-MM-YY";
		var timeFormat = "hh:mm A";
		var now, schedule, sehri, iftar, nextEvent;
		
		function updateInfo() {
			now = moment();
			schedule = Schedules[now.format(dateFormat)];
			
			sehri = moment(schedule.sehri, timeFormat);
			if( now.isAfter(sehri) ){
				var tmrw = now.clone().add(1, 'days');
				var schdl = Schedules[tmrw.format(dateFormat)];
				sehri = moment(schdl.sehri, timeFormat).add(1, 'days');
			}
			
			iftar = moment(schedule.iftar, timeFormat);
			if( now.isAfter(iftar) ){
				var tmrw = now.clone().add(1, 'days');
				var schdl = Schedules[tmrw.format(dateFormat)];
				iftar = moment(schdl.iftar, timeFormat).add(1, 'days');
			}
			
			var sehriCountdown = sehri.diff(now, 'seconds');
			var iftarCountdown = iftar.diff(now, 'seconds');
			
			var event;
			if( sehriCountdown < iftarCountdown ) {
				nextEvent = {type: "Sehri", countdown: sehriCountdown};
			} else {
				nextEvent = {type: "Iftar", countdown: iftarCountdown};
			}
			
			dayElm.text(schedule.day + "th Ramadan, 1440");
			dateElm.text(now.format("dddd - Do MMM"));
			sehriElm.text(sehri.format(timeFormat));
			iftarElm.text(iftar.format(timeFormat));
			waktTxtElm.text(nextEvent.type + " in ⮯");
		}
			
		function sehriAnimation(){
			// gif animation for last 10 mins sehri 
			var offset = 5*60;
			var start = Math.max(sehri.diff(now, 'seconds'), offset) - offset;
			var dur = sehri.diff(now, 'seconds') - start;

			setTimeout(function(){
				$('body').removeClass("iftar sehri").addClass("sehri");
				setTimeout(function(){
					$('body').removeClass("iftar sehri");
				}, dur * 1000);
			}, start * 1000);
		}
		
		function iftarAnimation(){
			// gif animation for the first 10 mins iftar
			var timeOutSecs = 5*60;
			$('body').removeClass("iftar sehri").addClass("iftar");
			setTimeout(function(){
				$('body').removeClass("iftar sehri");
			}, timeOutSecs * 1000);
		}
		
		
		updateInfo();
		
		var clock = timeElm.FlipClock({
			clockFace: 'TwelveHourClock',
			autoStart: true
		});
		var sehrCounter = sehriRemElm.FlipClock(sehri.diff(now, 'seconds'), {
			clockFace: 'HourlyCounter',
			autoStart: true,
			countdown: true,
			callbacks: {
				start: sehriAnimation
			}
		});
		var iftarCounter = iftarRemElm.FlipClock(iftar.diff(now, 'seconds'), {
			clockFace: 'HourlyCounter',
			autoStart: true,
			countdown: true,
			callbacks: {
				stop: iftarAnimation
			}
		});
		
		var mainCounter = mainClockElm.FlipClock(nextEvent.countdown, {
			clockFace: 'HourlyCounter',
			autoStart: true,
			countdown: true,
			// The onStop callback
			stop: function() {
				// delay 2 sec to let the current expire properly
				setTimeout(function(){
					//update day, sehri , iftar and everything
					updateInfo();
					
					waktTxtElm.text(nextEvent.type + " in ...");
					mainCounter.setTime(nextEvent.countdown);
					
					if(nextEvent.type == "Iftar"){
						// sehri ends: set next sehri counter
						sehrCounter.setTime(sehri.diff(now, "seconds"));
						sehrCounter.start();
					} else {
						// iftar starts: set next iftar counter
						iftarCounter.setTime(iftar.diff(now, "seconds"));
						iftarCounter.start();
					}
				}, 2000);	
			}
		});
		
		var themes = "theme-1 theme-2 theme-3 theme-4 theme-5";
		$(".theme-select").hover(function(evnt){
			$("body").removeClass(themes).addClass($(this).attr("themeClass"));
		});

	});
</script>

	</body>
</html>